from collections import OrderedDict
import torch
import torch.nn as nn
import torch.nn.functional as F
from timm.models.vision_transformer import trunc_normal_
import torchvision
from torchvision.models.segmentation import fcn_resnet50, FCN_ResNet50_Weights
from torchvision.models.segmentation import deeplabv3_resnet50
from torchvision.models import resnet50, ResNet50_Weights


class FCNResnet50(nn.Module):
    def __init__(self, random_weights=False):
        super().__init__()
        # if random_weights:
        #     self.fcn = fcn_resnet50(weights=None)
        # else:
        #     # self.fcn = fcn_resnet50(weights=FCN_ResNet50_Weights.DEFAULT)
        #     # self.fcn = torchvision.models.detection.keypointrcnn_resnet50_fpn(pretrained=True)
        #     # self.fcn = fcn_resnet50(weights=None)
        #     # self.fcn = deeplabv3_resnet50(pretrained=True)
        
        # self.fcn = resnet50(weights="IMAGENET1K_V2")
        self.fcn = resnet50(weights=None)


        # self.fcn_m = torchvision.models._utils.IntermediateLayerGetter(self.fcn.backbone, {'layer4': 0})
        # self.fcn_m = torchvision.models._utils.IntermediateLayerGetter(self.fcn.backbone, {'fpn': 0})
        # self.fcn_m.eval()
        self.fcn.eval()

    def _process_input(self, x):
        return x

    def forward_feats(self, x):
        # breakpoint()
        # x = self._process_input(x)
        # breakpoint()
        # return self.fcn_m(x)[0]
        # return self.fcn_m(x)[0]['3']
        # return self.fcn.backbone(x)['out']

        x = self.fcn.conv1(x)
        x = self.fcn.bn1(x)
        x = self.fcn.relu(x)
        x = self.fcn.maxpool(x)

        x = self.fcn.layer1(x)
        x = self.fcn.layer2(x)
        x = self.fcn.layer3(x)
        x = self.fcn.layer4(x)
        return x

    def forward(self, x):
        return self.backbone(x)