from collections import OrderedDict
import torch
import torch.nn as nn
import torch.nn.functional as F
from timm.models.vision_transformer import trunc_normal_
import torchvision
from torchvision.models.segmentation import fcn_resnet50, FCN_ResNet50_Weights


class FCNResnet50(nn.Module):
    def __init__(self):
        super().__init__()
        self.fcn = fcn_resnet50(weights=FCN_ResNet50_Weights.DEFAULT)
        self.fcn.eval()

    def _process_input(self, x):
        return x

    def forward_feats(self, x):
        x = self._process_input(x)
        return self.fcn.backbone(x)['out']

    def forward(self, x):
        return self.backbone(x)